Naeem Esfahani                                                                810180158

//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ mway.h $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
#ifndef __MWAY_H_
#define __MWAY_H_


#include <vector>
#include <iostream>
#include <fstream>
#include <time.h>
using namespace std;

void filer();

struct Node{
	ifstream file;
	int numread;

	Node(const char * name) :file(name){numread = 0;}
	~Node(){file.close();}
};

struct AnotherNode{
	ofstream file;
	int numwrite;

	AnotherNode(const char * name) :file(name){numwrite = 0;}
	~AnotherNode(){file.close();}
};

class MWEMS{
public:
	MWEMS(vector<const char *> & files);
private:
	vector<Node *> source_files;//hold source files
	//hold the files that cannot be used in that step
	vector<Node *> patient_files;
	vector<AnotherNode *> destination_files;//hold destintion files
	vector<int> current_data;//the latest data of each file
	vector<const char *> pathofinfiles;//path of input files
	vector<const char *> pathoftmpfiles;//path of temp files
	int numberofiles;//number of files that isn't empty yet
	//if 0:input ---> temp
	//if 1:temp  ---> input
	int phase;

	int findmin();
	void readmdata(int m);
	void deal_with(int where,int frequency,int limit,int pay);
	void eliminate(int where);
	void loader();
	void decnumberofiles();
	void statix();

	void sorter(int numberofmyfiles);
};


#endif
//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ fileproduse.cpp $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
#include "mway.h"

void filer()
{
	srand(time(0));
	ofstream file1("h:\\files\\s1.txt");
	ofstream file2("h:\\files\\s2.txt");
	ofstream file3("h:\\files\\s3.txt");

	int end1 = rand() % 100;
	int end2 = rand() % 100;
	int end3 = rand() % 100;

	for(int count = 0;count < end1;count++)
		file1 << rand() << ' ';
	for(count = 0;count < end2;count++)
		file2 << rand() << ' ';
	for(count = 0;count < end3;count++)
		file3 << rand() << ' ';

	file1.close();
	file2.close();
	file3.close();
}
//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ mway.cpp $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
#include "mway.h"

//find the minimum value in current_data vector
int MWEMS::findmin()
{
	int end = current_data.size();
	int min = current_data[0];
	int index = 0;

	for(int count = 1;count < end;count++)
		if(current_data[count] < min)
			min = current_data[index = count];

	return index;
}

//merge m integer of each file with m integer of other file each step 
//NOTE: the last step is when all files are closed
void MWEMS::readmdata(int m)
{
	int limit = m;
	int frequency = 1;
	while(source_files.size() != 0 || patient_files.size() != 0)//last step
	{
		loader();//files brought from patient_files vector

		while(current_data.size() != 0)
			//decide what to do with file after writing its value
			deal_with(findmin(),frequency,limit,pathofinfiles.size());

		//use to determine which file must be used for output
		frequency++;
		limit += m;//next step
	}
}

//decide what to do with file after writing its value
void MWEMS::deal_with(int where,int frequency,int limit,int pay)
{
	//out put the value
	destination_files[(frequency - 1) % pay]->file << current_data[where] << ' ';
	(destination_files[(frequency - 1) % pay]->numwrite)++;
	
	//try to read new value there are three situations
	//1:if the second number read from file in normal way
	//2:if eof occur this file is out of order for this m
	//3:if it has got its share(in this step) it will go to 
	//patient_files vector and in next step it'll be reloaded
	if((source_files[where]->numread) < limit)
	{
		source_files[where]->file >> current_data[where];
		source_files[where]->numread++;

		if(source_files[where]->file.eof())
			eliminate(where);
	}
	else
	{
		patient_files.push_back(source_files[where]);
		source_files.erase(source_files.begin() + where);
		current_data.erase(current_data.begin() + where);
	}
}

//eliminate one file and its dependent things
void MWEMS::eliminate(int where)
{
	delete source_files[where];
	source_files.erase(source_files.begin() + where);
	current_data.erase(current_data.begin() + where);	
}

//load source_files from patient_files in each step
//then try two fill current_data vector as well
//but if eof occurs that file must be eliminated
void MWEMS::loader()
{
	while(patient_files.size() != 0)
	{
		source_files.push_back(patient_files[patient_files.size() - 1]);
		patient_files.pop_back();
	}

	int end = source_files.size();
	current_data.resize(end);

	for(int count = 0;count < end;count++)
	{
		source_files[count]->file >> current_data[count];
		source_files[count]->numread++;

		if(source_files[count]->file.eof())
		{
			eliminate(count);
			end--;
			count--;
		}
	}
}

//check if one of output files became empty
void MWEMS::decnumberofiles()
{
	int end = destination_files.size();

	for(int count = 0;count < end;count++)
		if(destination_files[count]->numwrite == 0)
			numberofiles--;
}

//hire all the capability of all other methods and manage them
void MWEMS::sorter(int numberofmyfiles)
{
	int m = 1;//in the first time number of files is 1
	int end;
	int count;

	while(numberofiles != 1)
	{
		end = numberofiles;
		source_files.resize(end);
		destination_files.resize(end);

		//if phase == 0 input --> temp
		//if phase == 1 temp --> input
		switch (phase)
		{
		case 0:
			for(count = 0;count < end;count++)
			{
				source_files[count] = new Node(pathofinfiles[count]);
				destination_files[count] = new AnotherNode(pathoftmpfiles[count]);
			}
			break;
		case 1:
			for(count = 0;count < end;count++)
			{
				source_files[count] = new Node(pathoftmpfiles[count]);
				destination_files[count] = new AnotherNode(pathofinfiles[count]);
			}
			break;
		default:
			cerr << "CHAND TA FOHSH E BAD!!" << endl;
			break;
		}
		
		readmdata(m);//mrege m field of each file
		decnumberofiles();

		phase ^= 1;//0-->1 && 1-->0
		m *= numberofmyfiles;//m^0 m^1 m^2 m^3 ......

		//similar to destructor work
		for(count = source_files.size();count > 0;count--)
			delete source_files[count - 1];

		for(count = patient_files.size();count > 0;count--)
			delete patient_files[count - 1];

		for(count = destination_files.size();count > 0;count--)
			delete destination_files[count - 1];
	}
}

//intialize
MWEMS::MWEMS(vector<const char *> & files)
{
	numberofiles = files.size();
	phase = 0;
	pathofinfiles = files;

	statix();

	sorter(numberofiles);

	if(phase)
		cout << "The result is in the first temp file." << endl;
	else
		cout << "The result is in the first input file." << endl;
}

//just set the predifined names for temp files
void MWEMS::statix()
{
	pathoftmpfiles.push_back("h:\\files\\tmp1.txt");
	pathoftmpfiles.push_back("h:\\files\\tmp2.txt");
	pathoftmpfiles.push_back("h:\\files\\tmp3.txt");
	pathoftmpfiles.push_back("h:\\files\\tmp4.txt");
	pathoftmpfiles.push_back("h:\\files\\tmp5.txt");
	pathoftmpfiles.push_back("h:\\files\\tmp6.txt");
	pathoftmpfiles.push_back("h:\\files\\tmp7.txt");
	pathoftmpfiles.push_back("h:\\files\\tmp8.txt");
	pathoftmpfiles.push_back("h:\\files\\tmp9.txt");
	pathoftmpfiles.push_back("h:\\files\\tmp10.txt");
	pathoftmpfiles.push_back("h:\\files\\tmp11.txt");
	pathoftmpfiles.push_back("h:\\files\\tmp12.txt");
	pathoftmpfiles.push_back("h:\\files\\tmp13.txt");
	pathoftmpfiles.push_back("h:\\files\\tmp14.txt");
	pathoftmpfiles.push_back("h:\\files\\tmp15.txt");
	pathoftmpfiles.push_back("h:\\files\\tmp16.txt");
}
//$$$$$$$$$$$$$$$$$$$$$$$$$$$$ main.cpp $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
#include "mway.h"

void main()
{
	filer();
	vector<const char *> adr;
	adr.push_back("h:\\files\\s1.txt");
	adr.push_back("h:\\files\\s2.txt");
	adr.push_back("h:\\files\\s3.txt");
	MWEMS problem(adr);
}
//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ That's it! $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$